/*********************************************************************************
** SQL Server Security
** von Thomas Glrfeld
** mitp Verlag
** ISBN 978-3-8266-9421-9 fr die Print-Ausgabe
** ISBN 978-3-8266-9422-6 fr das e-Book als PDF
** ISBN 978-3-8266-9423-6 fr das e-Book als ePUB
** http://sql-security.de/
**********************************************************************************
** SQL-Security.sql		Version 1	25.06.2013
** 
** Das vorliegende Skript legt die Beispieldatenbank "SQL-Security" fr das
** Buch "SQL Server Security" an. Es muss von einem Benutzer mit SysAdmin-Rechten 
** eingespielt werden.
**
** Fehler
**
** Sollten Sie Fehler festellen, dann wrden wir uns ber eine Info freuen:
** Thomas@sql-security.de
**
*********************************************************************************/

USE master;
GO
SET ANSI_NULLS ON;
SET QUOTED_IDENTIFIER ON;
SET ANSI_PADDING ON;
SET LANGUAGE GERMAN;
GO
----- Datenbank aufrumen ----------------------------------------------------
/* Aufrumen, falls ntig:
USE master;
IF DB_ID('SQL-Security') IS NOT NULL
    DROP DATABASE [SQL-Security];

IF DB_ID('ContainedDB') IS NOT NULL
	DROP DATABASE [ContainedDB];

IF DB_ID('DB1') IS NOT NULL
	DROP DATABASE [DB1];
IF DB_ID('DB2') IS NOT NULL
	DROP DATABASE [DB2];
*/
GO
----- In masterDb aufrumen: Logins lschen, etc. -------------------------------------------------
IF SUSER_ID('MiniAdmins') IS NOT NULL			DROP SERVER ROLE MiniAdmins;
IF SUSER_ID(N'BIGBLACK\Bert') IS NOT NULL		DROP LOGIN [BIGBLACK\Bert];
IF SUSER_ID(N'BIGBLACK\Ernie') IS NOT NULL		DROP LOGIN [BIGBLACK\Ernie];
IF SUSER_ID(N'BIGBLACK\datareader') IS NOT NULL	DROP LOGIN [BIGBLACK\datareader];
IF SUSER_ID(N'James') IS NOT NULL				DROP LOGIN [James];
IF SUSER_ID(N'BigBird') IS NOT NULL				DROP LOGIN [BigBird];
IF SUSER_ID('test') IS NOT NULL 				DROP LOGIN test;
IF SUSER_ID('sigexecutor') IS NOT NULL 			DROP LOGIN [sigexecutor];
IF SUSER_ID('ProcOwner') IS NOT NULL 			DROP LOGIN ProcOwner;
IF SUSER_ID('ProcUser') IS NOT NULL 			DROP LOGIN ProcUser;
IF USER_ID(N'user_mit_login') IS NOT NULL		DROP USER user_mit_login; -- User aus MasterDB lschen
IF SUSER_ID(N'user_mit_login') IS NOT NULL		DROP LOGIN user_mit_login;
IF USER_ID(N'certlogin') IS NOT NULL			DROP USER certlogin; -- User aus MasterDB lschen
IF SUSER_ID(N'certlogin') IS NOT NULL			DROP LOGIN certlogin;

GO
IF OBJECT_ID('dbo.p_import_data') IS NOT NULL	DROP PROCEDURE dbo.p_import_data; -- Proc aus MasterDB lschen
GO
ALTER SERVER AUDIT [Logins und Logout]	WITH (STATE = OFF);
ALTER SERVER AUDIT SPECIFICATION [An- und abmeldungen] WITH (STATE = OFF);

IF EXISTS (SELECT * FROM sys.server_audit_specifications WHERE name = 'An- und abmeldungen')
	DROP SERVER AUDIT SPECIFICATION [An- und abmeldungen];

IF EXISTS(SELECT * FROM sys.server_audits WHERE name = 'Logins und Logout')
	DROP SERVER AUDIT [Logins und Logout];
GO
ALTER SERVER AUDIT [Zugriffe]	WITH (STATE = OFF);
ALTER SERVER AUDIT SPECIFICATION [DB-Objekt-Zugriffe] WITH (STATE = OFF);

IF EXISTS (SELECT * FROM sys.server_audit_specifications WHERE name = 'Zugriffe')
	DROP SERVER AUDIT SPECIFICATION [Zugriffe];

IF EXISTS(SELECT * FROM sys.server_audits WHERE name = 'DB-Objekt-Zugriffe')
	DROP SERVER AUDIT [DB-Objekt-Zugriffe];
GO
IF EXISTS(SELECT * FROM sys.server_event_sessions WHERE name = 'Anmeldungen')
	DROP EVENT SESSION [Anmeldungen] ON SERVER;



GO
----- Datenbank anlegen ----------------------------------------------------
IF DB_ID('SQL-Security') IS NULL
	CREATE DATABASE [SQL-Security];
GO
ALTER DATABASE [SQL-Security] SET RECOVERY SIMPLE;
ALTER DATABASE [SQL-Security] SET TRUSTWORTHY OFF;

GO
USE [SQL-Security];
GO
-- CDC ausschalten --------------------------------------------------------------
IF EXISTS(SELECT * FROM sys.tables WHERE name = 'users' AND [schema_id] = SCHEMA_ID('hashdemo') AND is_tracked_by_cdc=1)
	EXEC sys.sp_cdc_disable_table 
		@source_schema='hashdemo',
		@source_name='users',
		@capture_instance='hashdemo_users';
GO
IF EXISTS(SELECT * FROM sys.databases WHERE name = 'SQL-Security' AND is_cdc_enabled=1)
	EXEC sys.sp_cdc_disable_db;
GO
GO
----- Prozeduren entfernen -----------------------------------------------------
IF OBJECT_ID('sales.p_add_customer') IS NOT NULL 					DROP PROCEDURE sales.p_add_customer;
IF OBJECT_ID('sales.p_insert_creditcard') IS NOT NULL 				DROP PROCEDURE sales.p_insert_creditcard;
IF OBJECT_ID(N'sales.p_add_customer_with_log') IS NOT NULL 			DROP PROCEDURE sales.p_add_customer_with_log;
IF OBJECT_ID(N'sales.p_upd_customer_contact_with_log') IS NOT NULL 	DROP PROCEDURE sales.p_upd_customer_contact_with_log;
IF OBJECT_ID(N'test.write_A') IS NOT NULL 							DROP PROCEDURE test.write_A;
IF OBJECT_ID('staff.change_employee_middlename') IS NOT NULL		DROP PROCEDURE staff.change_employee_middlename;
IF OBJECT_ID('otherschema.update_A') IS NOT NULL					DROP PROCEDURE otherschema.update_A;
IF OBJECT_ID('test3.p_add_customer') IS NOT NULL					DROP PROCEDURE test3.p_add_customer;
IF OBJECT_ID('dbo.p_readorders', 'P') IS NOT NULL					DROP PROCEDURE dbo.p_readorders;
IF OBJECT_ID('dbo.p_readorders_wp', 'P') IS NOT NULL				DROP PROCEDURE dbo.p_readorders_wp;
IF OBJECT_ID('hashdemo.p_check_password') IS NOT NULL				DROP PROCEDURE hashdemo.p_check_password
IF OBJECT_ID('hashdemo.p_set_password') IS NOT NULL					DROP PROCEDURE hashdemo.p_set_password
IF OBJECT_ID('dbo.p_bulkimport') IS NOT NULL						DROP PROCEDURE dbo.p_bulkimport;
IF OBJECT_ID('other.p_bulkimport') IS NOT NULL						DROP PROCEDURE other.p_bulkimport;
IF OBJECT_ID('OwnerContext.p_ExecuteAsUser') IS NOT NULL			DROP PROCEDURE OwnerContext.p_ExecuteAsUser;
IF OBJECT_ID('OwnerContext.p_ExecuteAsOwner') IS NOT NULL			DROP PROCEDURE OwnerContext.p_ExecuteAsOwner;
IF OBJECT_ID('OwnerContext.p_ExecuteAsCaller') IS NOT NULL			DROP PROCEDURE OwnerContext.p_ExecuteAsCaller;
IF OBJECT_ID('OwnerContext.p_ExecuteAsSelf') IS NOT NULL			DROP PROCEDURE OwnerContext.p_ExecuteAsSelf;
IF OBJECT_ID('OwnerContext.p_add_customer') IS NOT NULL				DROP PROCEDURE OwnerContext.p_add_customer;
IF OBJECT_ID('OtherSchema.p_usertoken') IS NOT NULL					DROP PROCEDURE OtherSchema.p_usertoken;
IF OBJECT_ID('OtherSchema.p_add_customer') IS NOT NULL				DROP PROCEDURE OtherSchema.p_add_customer;
IF OBJECT_ID('dbo.p_import_data') IS NOT NULL
	
GO
----- Funktionen entfernen -----------------------------------------------------
IF OBJECT_ID('Sales.f_creditcards') IS NOT NULL 	DROP FUNCTION sales.f_creditcards;
IF OBJECT_ID('test3.f_orderdetails') IS NOT NULL	DROP FUNCTION test3.f_orderdetails;
IF OBJECT_ID('test3.f_orders') IS NOT NULL			DROP FUNCTION test3.f_orders;
IF OBJECT_ID('test3.f_customers') IS NOT NULL		DROP FUNCTION test3.f_customers;

GO
----- Sichten entfernen -----------------------------------------------------
IF OBJECT_ID('staff.emp_view') IS NOT NULL			DROP VIEW staff.emp_view;
IF OBJECT_ID('Sales.v_creditcards') IS NOT NULL 	DROP VIEW sales.v_creditcards;
IF OBJECT_ID('test.view_A') IS NOT NULL				DROP VIEW test.view_A;
IF OBJECT_ID('otherschema.emp_view') IS NOT NULL	DROP VIEW otherschema.emp_view;
IF OBJECT_ID('test1.v_orderdetails') IS NOT NULL	DROP VIEW test1.v_orderdetails;
IF OBJECT_ID('test1.v_orders') IS NOT NULL			DROP VIEW test1.v_orders;
IF OBJECT_ID('test1.v_customers') IS NOT NULL		DROP VIEW test1.v_customers;
IF OBJECT_ID('test1.v_customers2') IS NOT NULL		DROP VIEW test1.v_customers2;
IF OBJECT_ID('test2.v_orderdetails') IS NOT NULL	DROP VIEW test2.v_orderdetails;
IF OBJECT_ID('test2.v_orders') IS NOT NULL			DROP VIEW test2.v_orders;
IF OBJECT_ID('test2.v_customers') IS NOT NULL		DROP VIEW test2.v_customers;
IF OBJECT_ID('test3.v_orderdetails') IS NOT NULL	DROP VIEW test3.v_orderdetails;

GO
----- Tabellen entfernen -----------------------------------------------------
IF OBJECT_ID('staff.employees') IS NOT NULL 		DROP TABLE staff.employees;
IF OBJECT_ID('sales.creditcards') IS NOT NULL 		DROP TABLE sales.creditcards;
IF OBJECT_ID('sales.customers') IS NOT NULL 		DROP TABLE sales.customers;
IF OBJECT_ID('sales.customer_logs') IS NOT NULL		DROP TABLE sales.customer_logs;
IF OBJECT_ID('test.staging') IS NOT NULL 			DROP TABLE test.staging;
IF OBJECT_ID('test.tabelle_A') IS NOT NULL 			DROP TABLE test.tabelle_A;
IF OBJECT_ID('dbo.tab1') IS NOT NULL 				DROP TABLE dbo.tab1;
IF OBJECT_ID('test.tab1') IS NOT NULL 				DROP TABLE test.tab1;
IF OBJECT_ID('test1.orderdetails') IS NOT NULL		DROP TABLE test1.orderdetails;
IF OBJECT_ID('test1.orders') IS NOT NULL			DROP TABLE test1.orders;
IF OBJECT_ID('test1.customers') IS NOT NULL			DROP TABLE test1.customers;
IF OBJECT_ID('test1.books') IS NOT NULL				DROP TABLE test1.books;
IF OBJECT_ID('test2.user2customers') IS NOT NULL	DROP TABLE test2.user2customers;
IF OBJECT_ID('test2.orderdetails') IS NOT NULL		DROP TABLE test2.orderdetails;
IF OBJECT_ID('test2.orders') IS NOT NULL			DROP TABLE test2.orders;
IF OBJECT_ID('test2.customers') IS NOT NULL			DROP TABLE test2.customers;
IF OBJECT_ID('test2.books') IS NOT NULL				DROP TABLE test2.books;
IF OBJECT_ID('test.books') IS NOT NULL				DROP TABLE test.books;
IF OBJECT_ID('test3.user2customers') IS NOT NULL	DROP TABLE test3.user2customers;
IF OBJECT_ID('test3.orderdetails') IS NOT NULL		DROP TABLE test3.orderdetails;
IF OBJECT_ID('test3.orders') IS NOT NULL			DROP TABLE test3.orders;
IF OBJECT_ID('test3.customers') IS NOT NULL			DROP TABLE test3.customers;
IF OBJECT_ID('test3.books') IS NOT NULL				DROP TABLE test3.books;
IF OBJECT_ID('test3.users') IS NOT NULL				DROP TABLE test3.users;
IF OBJECT_ID('dbo.customers') IS NOT NULL			DROP TABLE dbo.customers;
IF OBJECT_ID('dbo.orders') IS NOT NULL				DROP TABLE dbo.orders;
IF OBJECT_ID('dbo.trans') IS NOT NULL				DROP TABLE dbo.trans;
IF OBJECT_ID('dbo.users') IS NOT NULL				DROP TABLE dbo.[users];
IF OBJECT_ID('hashdemo.users') IS NOT NULL			DROP TABLE hashdemo.users;
IF OBJECT_ID('changecheck1.customers_copy') IS NOT NULL DROP TABLE changecheck1.customers_copy;
IF OBJECT_ID('changecheck1.customers') IS NOT NULL	DROP TABLE changecheck1.customers;
IF OBJECT_ID('changecheck2.customers') IS NOT NULL	DROP TABLE changecheck2.customers;
IF OBJECT_ID('changecheck3.customers') IS NOT NULL	DROP TABLE changecheck3.customers;

GO
----- Schemata lschen -----------------------------------------------------
IF SCHEMA_ID('staff') IS NOT NULL				DROP SCHEMA staff;
IF SCHEMA_ID('sales') IS NOT NULL				DROP SCHEMA sales;
IF SCHEMA_ID('Bigblack\Ernie') IS NOT NULL		DROP SCHEMA [Bigblack\Ernie];
IF SCHEMA_ID(N'myapprole') IS NOT NULL			DROP SCHEMA myapprole;
IF SCHEMA_ID(N'otherschema') IS NOT NULL		DROP SCHEMA otherschema;
IF SCHEMA_ID(N'schemabesitzer') IS NOT NULL		DROP SCHEMA schemabesitzer;
IF SCHEMA_ID(N'tabellenanleger') IS NOT NULL	DROP SCHEMA tabellenanleger;
IF SCHEMA_ID('test') IS NOT NULL				DROP SCHEMA test;
IF SCHEMA_ID('test1') IS NOT NULL				DROP SCHEMA test1;
IF SCHEMA_ID('test2') IS NOT NULL				DROP SCHEMA test2;
IF SCHEMA_ID('test3') IS NOT NULL				DROP SCHEMA test3;
IF SCHEMA_ID('hashdemo') IS NOT NULL			DROP SCHEMA hashdemo;
IF SCHEMA_ID('changecheck1') IS NOT NULL		DROP SCHEMA changecheck1;
IF SCHEMA_ID('changecheck2') IS NOT NULL		DROP SCHEMA changecheck2;
IF SCHEMA_ID('changecheck3') IS NOT NULL		DROP SCHEMA changecheck3;
IF SCHEMA_ID('other') IS NOT NULL				DROP SCHEMA other;
IF SCHEMA_ID('OwnerContext') IS NOT NULL		DROP SCHEMA OwnerContext;
IF SCHEMA_ID('OtherSchema') IS NOT NULL			DROP SCHEMA OtherSchema;

GO
---- Zertificate lschen ----------------------------------------------
IF CERT_ID(N'c_sqlsecurity') IS NOT NULL		DROP CERTIFICATE c_sqlsecurity;
IF CERT_ID(N'c_sqlsecurity2') IS NOT NULL		DROP CERTIFICATE c_sqlsecurity2;
IF CERT_ID(N'c_sqlsecurity3') IS NOT NULL		DROP CERTIFICATE c_sqlsecurity3;
IF CERT_ID(N'c_sqlsecurity4') IS NOT NULL		DROP CERTIFICATE c_sqlsecurity4;
IF CERT_ID('c_logincert') IS NOT NULL			DROP CERTIFICATE c_logincert ;

GO
EXEC sp_configure 'show ad', 1;					RECONFIGURE;
GO
EXEC sp_configure 'xp_cmdshell', 1;				RECONFIGURE;
GO
EXEC xp_cmdshell 'DEL C:\SQL-Security\Data\service_master_key.key';

GO
---- Schlssel lschen ----------------------------------------------
IF AsymKey_ID('k_asym_rsa2048') IS NOT NULL		DROP ASYMMETRIC KEY k_asym_rsa2048;
IF AsymKey_ID('k_asym_2') IS NOT NULL			DROP ASYMMETRIC KEY k_asym_2;
IF AsymKey_ID('k_asym_rsa') IS NOT NULL			DROP ASYMMETRIC KEY k_asym_rsa;
IF Key_GUID('k_sym1_aes256') IS NOT NULL		DROP SYMMETRIC KEY k_sym1_aes256;
IF Key_GUID('k_sym2_TRIPLE_DES') IS NOT NULL	DROP SYMMETRIC KEY k_sym2_TRIPLE_DES; 
IF Key_GUID('k_sym3_aes256') IS NOT NULL		DROP SYMMETRIC KEY k_sym3_aes256;

GO
---- User lschen und ggf. neu anlegen  ----------------------------------------------

IF USER_ID(N'BIGBLACK\Bert') IS NOT NULL		DROP USER [BIGBLACK\Bert];
IF USER_ID(N'BIGBLACK\datareader') IS NOT NULL	DROP USER [BIGBLACK\datareader];
IF USER_ID(N'Bigblack\Ernie') IS NOT NULL		DROP USER [Bigblack\Ernie];
IF USER_ID(N'BigBird') IS NOT NULL				DROP USER BigBird;
IF USER_ID(N'Nobody') IS NOT NULL				DROP USER Nobody;
IF USER_ID(N'otheruser') IS NOT NULL			DROP USER otheruser;
IF USER_ID(N'schemabesitzer') IS NOT NULL		DROP USER schemabesitzer;
IF USER_ID(N'testuser') IS NOT NULL				DROP USER testuser;
IF USER_ID(N'testreader') IS NOT NULL			DROP USER testreader;
IF USER_ID(N'testwriter') IS NOT NULL			DROP USER testwriter;
IF USER_ID(N'tabellenbesitzer') IS NOT NULL		DROP USER tabellenbesitzer;
IF USER_ID(N'Tom') IS NOT NULL					DROP USER [Tom];
IF USER_ID(N'Bill') IS NOT NULL					DROP USER [Bill];
IF USER_ID(N'Mac') IS NOT NULL					DROP USER [Mac];
IF USER_ID(N'employee') IS NOT NULL				DROP USER [employee];
IF USER_ID(N'certuser') IS NOT NULL				DROP USER certuser;
IF USER_ID(N'user1') IS NOT NULL				DROP USER user1;
IF USER_ID(N'user2') IS NOT NULL				DROP USER user2;
IF USER_ID('sigexecutor') IS NOT NULL 			DROP USER sigexecutor; 
IF USER_ID('executor') IS NOT NULL 				DROP USER executor; 
IF USER_ID('ProcOwner') IS NOT NULL 			DROP USER ProcOwner; 
IF USER_ID('ProcUser') IS NOT NULL 				DROP USER ProcUser; 
IF USER_ID(N'user_ohne_login') IS NOT NULL		DROP USER user_ohne_login;
IF USER_ID(N'user_mit_login') IS NOT NULL		DROP USER user_mit_login;

GO
IF USER_ID(N'employee') IS NULL					CREATE USER [employee] WITHOUT LOGIN;

GO
---- Rollen lschen und neu anlegen  --------------------------------------------
IF USER_ID(N'myapprole') IS NOT NULL			DROP APPLICATION ROLE myapprole;
GO
IF USER_ID(N'employees') IS NOT NULL			DROP ROLE employees;
IF USER_ID(N'sales_modificator') IS NOT NULL	DROP ROLE sales_modificator;
IF USER_ID(N'role1') IS NOT NULL			    DROP ROLE [role1];
IF USER_ID(N'role2') IS NOT NULL			    DROP ROLE [role2];
IF USER_ID(N'innerrole') IS NOT NULL			DROP ROLE innerrole;
IF USER_ID(N'outerrole') IS NOT NULL			DROP ROLE outerrole;
IF USER_ID(N'readerrole') IS NOT NULL			DROP ROLE readerrole;
IF USER_ID(N'writerrole') IS NOT NULL			DROP ROLE writerrole;
IF USER_ID(N'funcuserrole') IS NOT NULL			DROP ROLE funcuserrole;
IF USER_ID(N'adminrole') IS NOT NULL			DROP ROLE adminrole;
GO
IF USER_ID(N'funcuserrole') IS NULL				CREATE ROLE funcuserrole;
IF USER_ID(N'adminrole') IS NULL				CREATE ROLE adminrole;
IF USER_ID(N'employees') IS NULL			    CREATE ROLE [employees];

GO
----- Schemata anlegen -----------------------------------------------------
CREATE SCHEMA [staff]	AUTHORIZATION [dbo];
GO
CREATE SCHEMA [sales]	AUTHORIZATION [dbo];
GO
CREATE SCHEMA [test]	AUTHORIZATION [dbo];
GO
CREATE SCHEMA [test1] 	AUTHORIZATION [dbo];
GO
CREATE SCHEMA [test2] 	AUTHORIZATION [dbo];
GO
CREATE SCHEMA [test3] 	AUTHORIZATION [dbo];
GO
CREATE SCHEMA hashdemo 	AUTHORIZATION [dbo];
GO
CREATE SCHEMA changecheck1 	AUTHORIZATION [dbo];
GO
CREATE SCHEMA changecheck2 	AUTHORIZATION [dbo];
GO
CREATE SCHEMA changecheck3 	AUTHORIZATION [dbo];

GO
----- Tabellen anlegen -----------------------------------------------------
CREATE TABLE staff.employees
(
	empid		BIGINT			NOT NULL,
	lastname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL ,
	firstname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL ,
	middlename	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	phone		NVARCHAR(20)	COLLATE Latin1_General_CI_AS	NULL ,
	picture		VARBINARY(MAX)	NULL ,
	jobdescr	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL  DEFAULT 'Sales Manager',
	award		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL,
	username	SYSNAME			COLLATE Latin1_General_CI_AS	NULL, 
	CONSTRAINT [pk_employees_empid] PRIMARY KEY CLUSTERED (empid ASC)
);
GO
INSERT INTO staff.employees 
		(empid, lastname,	firstname,		middlename,		phone,			jobdescr,					username)
VALUES
		(1	,N'Kirk',       N'James',		N'Tiberius',	N'01234-12345',	N'Boss',					N'Jim'),
		(2	,N'Glrfeld',	N'Thomas',		NULL,			N'08674-34545', N'Chief of Inexperience',	N'Thomas'),
		(3	,N'Meier',		N'Birte',		N'Angelika',	N'04565-64343', N'Super Sales Agent',		N'Birte'),
		(4	,N'Mueller',	N'Hans',		N'Heinrich',	N'01234-34341', DEFAULT,					N'Hans'),
		(5	,N'Schmidt',	N'Matthias',	NULL,			N'08764-43246', N'IT Admin',				N'Matthias'),
		(6	,N'Tromps',		N'Gerda',		N'Gretchen',	N'09734-53468', DEFAULT,					N'Gerda'),
		(7	,N'Tan',		N'Kim',			N'Joe',			N'01239-56345', N'Buying Agent',			N'Kim'),
		(8	,N'Huber',		N'Nicole',		NULL,			N'01987-19748', DEFAULT,					N'Nicole'),
		(9	,N'Bauer',		N'Jasmin',		N'Adelina',		N'01799-97349', N'Secretary',				N'Jasmin'),
		(10	,N'Berger',		N'Gustav',		NULL,			NULL,			DEFAULT,					N'Gustav')
;
GO
CREATE VIEW staff.emp_view
AS
SELECT empid, lastname,	firstname, middlename, username
FROM staff.employees;
GO
CREATE TABLE sales.customers
(
	custid		BIGINT			NOT NULL,
	compname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL ,
	contact		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	city		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	country		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	currid		CHAR(3)			COLLATE Latin1_General_CI_AS	NOT NULL	DEFAULT 'EUR',
	discount	smallint		NOT NULL DEFAULT 0,
	CONSTRAINT [pk_customers_custid] PRIMARY KEY CLUSTERED (custid ASC)
)
GO
INSERT INTO sales.customers 
		(custid, compname,				contact,				city,			country,		currid,		discount)
VALUES	
		(1,		N'Bcher Heinrich',		N'Thomas Heinrich',		N'Mnchen',		N'Deutschland',	N'EUR',		DEFAULT),
		(2,		N'London Books',		N'Steve Miller',		N'London',		N'Great Britain',	N'GBP',	5),
		(3,		N'modernes Antiquariat', N'Markus Buchbinder',	N'Kln',		N'Deutschland',	N'EUR',		2),
		(4,		N'Meiers Bcher',		N'Gustav Teuerkufer',	N'Nrnberg',	N'Deutschland',	N'EUR',		DEFAULT),
		(5,		N'Stberstube',			N'Hilda Hintersee',		N'Hamburg',		N'Deutschland',	N'EUR',		DEFAULT),
		(6,		N'Bcher Bucher',		N'Andreas Bucher',		N'Wien',		N'sterreich',	N'EUR',		DEFAULT),
		(7,		N'Bergers',				N'Carmen Berger',		N'Erlangen',	N'Deutschland',	N'EUR',		9),
		(8,		N'Schmker-Ecke',		N'Bernd Bauer',			N'Duisburg',	N'Deutschland',	N'EUR',		DEFAULT),
		(9,		N'Stberstube',			N'Elvira Sommer',		N'Bielefeld',	N'Deutschland',	N'EUR',		DEFAULT);
GO

----- Tabellen anlegen -----------------------------------------------------
CREATE TABLE sales.creditcards
(
	custid		BIGINT		NOT NULL,
	cardnum		VARBINARY(256)	NULL,
	CONSTRAINT [fk_creditcards_custid]  FOREIGN KEY (custid) REFERENCES sales.customers (custid)
);

GO
----- Tabellen anlegen -----------------------------------------------------
CREATE TABLE test.staging
(
	id			BIGINT	NOT NULL,
	lastname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL,
	firstname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL
);
GO
CREATE PROCEDURE Sales.p_add_customer
(
	@custid		BIGINT,
	@compname	NVARCHAR(100),
	@contact	NVARCHAR(100),	
	@city		NVARCHAR(100),	
	@country	NVARCHAR(100),	
	@currid		CHAR(3),
	@discount	SMALLINT
) 
AS
INSERT INTO sales.customers
		(custid,  compname,  contact,  city,  country,  currid,  discount)
VALUES	(@custid, @compname, @contact, @city, @country, @currid, @discount);

SELECT custid,  compname,  contact,  city,  country,  currid,  discount, USER_NAME() AS username
FROM sales.customers
WHERE custid=@custid;
GO

CREATE TABLE sales.customer_logs
(
	id			BIGINT	NOT NULL IDENTITY(1,1),
	custid		BIGINT	NULL,
	action		NVARCHAR(max) NULL,
	chgdate		DATETIME	DEFAULT GETDATE(),
	chguser		SYSNAME		DEFAULT USER_NAME(),
	CONSTRAINT [pk_user_logs_id] PRIMARY KEY NONCLUSTERED (id ASC)
);
GO
CREATE INDEX i_customer_logs_name ON sales.customer_logs(custid, chgdate);
GO
-------- Chpt 6 ---------------------
IF USER_ID(N'employees') IS NULL
    CREATE ROLE [employees];
GO
IF USER_ID(N'Tom') IS NOT NULL
	DROP USER [Tom];

CREATE USER [Tom] WITHOUT LOGIN;

ALTER ROLE [employees] ADD MEMBER [Tom];
GO
IF USER_ID(N'Bill') IS NOT NULL
	DROP USER [Bill];

CREATE USER [Bill] WITHOUT LOGIN;

ALTER ROLE [employees] ADD MEMBER [Bill];
GO
IF USER_ID(N'Mac') IS NOT NULL
	DROP USER [Mac];

CREATE USER [Mac] WITHOUT LOGIN;

ALTER ROLE [employees] ADD MEMBER [Mac];
GO
CREATE TABLE test1.books
(
	prodid		BIGINT		NOT NULL	IDENTITY(1,1),
	name		NVARCHAR(200)	COLLATE Latin1_General_CI_AS	NULL ,
	author		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	price		numeric(12,4)	NULL,
	CONSTRAINT [pk_product_prodid] PRIMARY KEY CLUSTERED (prodid ASC)
);
GO
-- Die Buchtitel stammen aus dem Gutenberg-Projekt. Dort findet man alle genannten bcher zum freuien Download
-- http://gutenberg.spiegel.de/
--
INSERT INTO test1.books (author, name)
VALUES
(N'Adolph, Karl', N'Haus Nummer 37'),
(N'Aho, Juhani', N'Schweres Blut'),
(N'Aho, Juhani', N'Gechtet'),
(N'Alarcn, Pedro Antonio de', N'Manuel Venegas'),
(N'Alberti, Karl', N'Japanische Mrchen'),
(N'Alexis, Willibald', N'Der Roland von Berlin  Erster Band'),
(N'Alexis, Willibald', N'Der Roland von Berlin  Zweiter Band'),
(N'Alexis, Willibald', N'Der Roland von Berlin  Dritter Band'),
(N'Andreas-Salom, Lou', N'Lebensrckblick'),
(N'Arnd, Friedrich', N'Das hohe Ziel der Erkenntnis'),
(N'Amicis, Edmondo De', N'Unsere Freunde'),
(N'Andrejew, Leonid Nikolajewitsch', N'Die Geschichte von den sieben Gehenkten'),
(N'Aram, Kurt', N'An den Ufern des Araxes'),
(N'Aretz, Gertrude', N'Berhmte Frauen der Weltgeschichte'),
(N'Arnim, Achim von', N'Erzhlungen'),
(N'Arnim, Achim von', N'Das Frhlingsfest'),
(N'Arnim, Achim von', N'Gedichte'),
(N'Arnim, Achim von', N'Die Gleichen'),
(N'Arnim, Achim von', N'Marino Caboga'),
(N'Arnim, Achim von', N'Miverstndnisse'),
(N'Arnim, Achim von', N'Die Vertreibung der Spanier aus Wesel im Jahre 1629'),
(N'Atterbom, Per Daniel Amadeus', N'Menschen und Stdte'),
(N'Auburtin, Victor', N'Das Ende des Odysseus'),
(N'Auburtin, Victor', N'Sndenflle. Feuilletons'),
(N'Auerbach, Berthold', N'Der Kindesmord'),
(N'Austen, Jane', N'Edgar und Emma'),
(N'Bahr, Hermann', N'Dostojewski'),
(N'Bahr, Hermann', N'Kritik der Gegenwart'),
(N'Balzac, Honor de', N'Adieu'),
(N'Balzac, Honor de', N'Die Geheimnisse der Frstin von Cadignan'),
(N'Balzac, Honor de', N'Kehrseite der Geschichte unserer Zeit'),
(N'Balzac, Honor de', N'Die Lilie im Tal'),
(N'Balzac, Honor de', N'Das Haus Nucingen'),
(N'Balzac, Honor de', N'Physiologie der Ehe'),
(N'Balzac, Honor de', N'Ein Drama am Ufer des Meeres'),
(N'Bang, Herman', N'Novellen und Skizzen. Gesamtwerk Band 9'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1880'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1881'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1882'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1883'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1884  Anhang'),
(N'Barbusse, Henri', N'Das Frhlicht'),
(N'Barlach, Ernst', N'Fragmente aus frherer Zeit'),
(N'Barlach, Ernst', N'Gstrower Fragmente'),
(N'Barlach, Ernst', N'Protokolle und Portrts'),
(N'Barlach, Ernst', N'Schriften in eigener Sache'),
(N'Barlach, Ernst', N'Seespeck'),
(N'Barlach, Ernst', N'Ein selbsterzhltes Leben'),
(N'Barthel, Max', N'Deutschland - Lichtbilder und Schattenrisse einer Reise'),
(N'Baudissin, Wolf Graf von', N'Die Kriegsurlauber'),
(N'Baumbach, Rudolf', N'Abenteuer und Schwnke'),
(N'Baumbach, Rudolf', N'Horand und Hilde'),
(N'Bebel, August', N'Aus meinem Leben  Erster Teil'),
(N'Bebel, August', N'Aus meinem Leben  Zweiter Teil'),
(N'Bebel, August', N'Die mohamedanisch-arabische Kulturperiode'),
(N'Bechstein, Ludwig', N'Der Dunkelgraf'),
(N'Bechstein, Ludwig', N'Rheinsagen'),
(N'Beeker, Kthe van', N'Hansis Europareise'),
(N'Beeker, Kthe van', N'Hansis Europareise'),
(N'Benjamin, Walter', N'Deutsche Menschen'),
(N'Benjamin, Walter', N'Stdtebilder'),
(N'Benjamin, Walter', N'Kritiken und Rezensionen 1912  1931'),
(N'Benjamin, Walter', N'Kritiken und Rezensionen 1932  1940'),
(N'Berend, Alice', N'Die gute alte Zeit'),
(N'Berend, Alice', N'Bruders Bekenntnis'),
(N'Berend, Alice', N'Frau Hempels Tochter'),
(N'Berend, Alice', N'Spreemann & Co'),
(N'Berend, Alice', N'Das verbrannte Bett'),
(N'Beringer, Josef August', N'Studien zur Deutschen Kunstgeschichte  Hermann Braun'),
(N'Bermann, Richard Arnold', N'Die Derwischtrommel'),
(N'Berthold, Theodor', N'Lustige Gymnasialgeschichten'),
(N'Bessels, Emil', N'196 Tage auf treibender Eisscholle'),
(N'Bierbaum, Otto Julius', N'Das hllische Automobil'),
(N'Bierbaum, Otto Julius', N'Das Madei'),
(N'Bierbaum, Otto Julius', N'Dostojewski'),
(N'Bierbaum, Otto Julius', N'Die Lavendel-Ehe'),
(N'Bierbaum, Otto Julius', N'Die rote Sphinx'),
(N'Bierbaum, Otto Julius', N'Die Weihnachts-Bowle'),
(N'Bierbaum, Otto Julius', N'Im Kahne'),
(N'Bierbaum, Otto Julius', N'Patsch und Tirili'),
(N'Bierbaum, Otto Julius', N'Schwarz-Rot-Gold und Grn-Wei-Rot'),
(N'Binding, Rudolf Georg', N'Legenden'),
(N'Binding, Rudolf Georg', N'Unsterblichkeit'),
(N'Binding, Rudolf Georg', N'Der Wingult'),
(N'Bischoff, Charitas', N'Bilder aus meinem Leben'),
(N'Bjrnson, Bjrnstjerne', N'Gedichte'),
(N'Bleibtreu, Karl', N'Bismarck  Band 4'),
(N'Bode, Wilhelm von', N'Fnfzig Jahre Museumsarbeit'),
(N'Bodenstedt, Friedrich von', N'Die Lieder des Mirza-Schaffy'),
(N'Bodenstedt, Friedrich von', N'Tausend und Ein Tag im Orient'),
(N'Bodkin, Mathias McDonnell', N'Giftmischer und andre Detektivgeschichten'),
(N'Bhlau, Helene', N'Altweimarische Liebes- und Ehegeschichten'),
(N'Bhlau, Helene', N'Die leichtsinnige Eheliebste'),
(N'Bhlau, Helene', N'Ein Sommerbuch'),
(N'Bhlau, Helene', N'Kristine'),
(N'Bhlau, Helene', N'Ratsmdelgeschichten'),
(N'Bhme, Margarete', N'Tagebuch einer Verlorenen'),
(N'Blsche, Wilhelm', N'Drachen'),
(N'Brne, Ludwig', N'Briefe aus Paris'),
(N'Bois-Reymond, Emil Heinrich du', N'ber die Grenzen des Naturerkennens  Die sieben Weltrthsel'),
(N'Bonaventura', N'Nachtwachen'),
(N'Brant, Sebastian', N'Das Narrenschiff'),
(N'Braun, Isabella', N'Gesammelte Erzhlungen'),
(N'Braun, Isabella', N'Geschichten aus der Jugendzeit'),
(N'Brentano, Clemens', N'Italienische Mrchen'),
(N'Blau, Friedrich von', N'Geheime Geschichten und rtselhafte Menschen  Zehntes Bndchen'),
(N'Bulwer-Lytton, Edward', N'Asmodeus aller Orten'),
(N'Bulwer-Lytton, Edward', N'Die Pilger des Rheins'),
(N'Burckhardt, Jacob', N'Reisebilder aus dem Sden'),
(N'Byr, Robert', N'Lydia'),
(N'Caldern de la Barca, Pedro', N'Das Versteckspiel'),
(N'Capek, Karel', N'Hordubal'),
(N'Carducci, Giosu', N'Gedichte'),
(N'Carducci, Giosu', N'Aus den Odi Barbare'),
(N'Carroll, Lewis', N'Alices Abenteuer im Wunderland'),
(N'Carus, Carl Gustav', N'Goethe zu dessen nherem Verstndnis'),
(N'Castelli, Ignaz', N'Wiener Lebensbilder'),
(N'Chamberlain, Houston Stewart', N'Kriegsaufstze'),
(N'Chamberlain, Houston Stewart', N'Mensch und Gott'),
(N'Christ, Lena', N'Lausdirndlgeschichten'),
(N'Cicero, Marcus Tullius', N'Reden gegen Verres'),
(N'Claudius, Matthias', N'Ein glden A B C'),
(N'Claudius, Matthias', N'Wiegenlied'),
(N'Clausewitz, Carl von', N'Kleine Schriften'),
(N'Colerus, Egmont', N'Zwei Welten - 1'),
(N'Colerus, Egmont', N'Zwei Welten - 2'),
(N'Colerus, Egmont', N'Leibniz'),
(N'Colerus, Egmont', N'Pythagoras'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band I'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band II'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band III'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band VI');
-- Titel und Autoren sind aus dem Gutenbergprojekt
GO
-- Preise vergeben 
WITH cte1 AS
(
	SELECT *
		FROM (VALUES (0, 3.99), (1, 8.99), (2, 7.99), (3, 6.99), (4, 5.50), (5, 12.90), (6, 24.90), (7, 10.50), (8, 9.50), (9, 9.99)
			 ) AS prices(n, price)
)
UPDATE b
	SET b.price = c.price
--OUTPUT inserted.prodid, inserted.price
FROM test1.books AS b
JOIN cte1 AS c
	ON b.prodid%10=c.n;
GO
CREATE TABLE test1.customers
(
	custid		BIGINT			NOT NULL,
	compname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL ,
	contact		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	city		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	country		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	currid		CHAR(3)			COLLATE Latin1_General_CI_AS	NOT NULL	DEFAULT 'EUR',
	discount	smallint		NOT NULL DEFAULT 0,
	uid			integer			NULL,
	CONSTRAINT [pk_customers_custid] PRIMARY KEY CLUSTERED (custid ASC)
);
GO
INSERT INTO test1.customers 
		(custid, compname,				contact,				city,			country,		currid,		discount,	uid)
VALUES	
		(1,		N'Bcher Heinrich',		N'Thomas Heinrich',		N'Mnchen',		N'Deutschland',	N'EUR',		DEFAULT,	user_id('Tom')),
		(2,		N'London Books',		N'Steve Miller',		N'London',		N'Great Britain',	N'GBP',	5,			user_id('Tom')),
		(3,		N'modernes Antiquariat', N'Markus Buchbinder',	N'Kln',		N'Deutschland',	N'EUR',		2,			user_id('Tom')),
		(4,		N'Meiers Bcher',		N'Gustav Teuerkufer',	N'Nrnberg',	N'Deutschland',	N'EUR',		DEFAULT,	user_id('Bill')),
		(5,		N'Stberstube',			N'Hilda Hintersee',		N'Hamburg',		N'Deutschland',	N'EUR',		DEFAULT,	user_id('Bill')),
		(6,		N'Bcher Bucher',		N'Andreas Bucher',		N'Wien',		N'sterreich',	N'EUR',		DEFAULT,	user_id('Bill')),
		(7,		N'Bergers',				N'Carmen Berger',		N'Erlangen',	N'Deutschland',	N'EUR',		9,			user_id('Mac')),
		(8,		N'Schmker-Ecke',		N'Bernd Bauer',			N'Duisburg',	N'Deutschland',	N'EUR',		DEFAULT,	user_id('Mac')),
		(9,		N'Stberstube',			N'Elvira Sommer',		N'Bielefeld',	N'Deutschland',	N'EUR',		DEFAULT,	user_id('Mac')),
		(10,	N'heimliche Bcher',	N'Gernot Meier',		N'Berlin',		N'Deutschland',	N'EUR',		DEFAULT,	user_id('Employees'));
GO
CREATE VIEW test1.v_customers
AS
SELECT custid, 
       compname,
	   contact,
	   city,
	   country,
	   currid,
	   discount,
	   uid
FROM test1.customers
WHERE uid=USER_ID();
GO
GRANT INSERT,UPDATE,DELETE,SELECT ON test1.v_customers TO employees;
GO
CREATE TABLE test1.orders
(
	ordid		BIGINT			NOT NULL	IDENTITY(1,1),
	custid		BIGINT			NOT NULL,
	uid			BIGINT			NULL		DEFAULT USER_ID(),
	orderdate	DATE			NOT NULL	DEFAULT CURRENT_TIMESTAMP,
	total		NUMERIC(20,4)	NULL,
	CONSTRAINT [pk_orders_ordid] PRIMARY KEY CLUSTERED (ordid ASC),
	CONSTRAINT [fk_orders_customers] FOREIGN KEY (custid) REFERENCES test1.customers (custid)
);
GO
CREATE VIEW test1.v_orders
AS
SELECT ordid, custid, uid, orderdate, total
FROM test1.orders
WHERE uid=USER_ID();
GO
GRANT INSERT,UPDATE,DELETE,SELECT ON test1.v_orders TO employees;
GO
SET LANGUAGE german;
GO

WITH		-- Zahlen von 1 bis 1500 erzeugen
c1 AS	(	SELECT a.n FROM (VALUES (1),(1)) AS a(n)	),	-- 2
c2 AS	(	SELECT a.n FROM c1 AS a CROSS JOIN c1 AS b),	-- 4
c3 AS	(	SELECT a.n FROM c2 AS a CROSS JOIN c2 AS b),	-- 16
c4 AS	(	SELECT a.n FROM c3 AS a CROSS JOIN c3 AS b),	-- 256
c5 AS	(	SELECT a.n FROM c4 AS a CROSS JOIN c4 AS b),    -- 256*256
num AS  (	SELECT TOP(1500) ROW_NUMBER() OVER (ORDER BY (SELECT NULL)) AS n	FROM c5),
			-- Datum von 1.1.2009 bis 30.6.2012 erzeugen
d1 AS	(	SELECT n, DATEADD(day, n, CAST('20090101' AS DATE)) AS dt
			FROM num 
			WHERE DATENAME(weekday, DATEADD(day, n, CAST('20090101' AS DATE))) NOT IN ('Sonntag','Samstag')
			  AND DATEADD(day, n, CAST('20090101' AS DATE)) <= CAST('20120630' AS DATE)),
dat	AS	(	SELECT	dt, -- "zufllige" Reihenfolge erzeugen
					ROW_NUMBER() OVER (ORDER BY MONTH(dt)+YEAR(dt)+DAY(dt), n ASC) AS r
			FROM d1),
cu AS	(	SELECT	custid, uid, LEN(city) AS v	FROM test1.customers	),
cu2 AS	(	SELECT ROW_NUMBER() OVER(ORDER BY d.dt) AS  orderid,
				c.uid, c.custid, d.dt AS orderdate
			FROM dat AS d
			JOIN cu  AS c
				ON d.r%c.v = 0)
INSERT INTO  test1.orders 
		(custid,	uid,	orderdate)
SELECT	custid,
		uid,
		orderdate
FROM cu2
ORDER BY orderdate ASC, uid DESC, custid	ASC;
GO
CREATE INDEX i_order_date ON test1.orders (orderdate ASC);
GO
CREATE TABLE test1.orderdetails (
	ordid		BIGINT		NOT NULL	
		CONSTRAINT fk_orderdetails_ordid FOREIGN KEY REFERENCES test1.orders(ordid),
	position	INT			NOT NULL,
	prodid		BIGINT		NOT NULL
		CONSTRAINT fk_orderdetails_prodid FOREIGN KEY REFERENCES test1.books (prodid),
	amount		INT			NOT NULL,
	price		numeric(12,4)	NULL,
	CONSTRAINT [pk_orderdetails_orderid_position] PRIMARY KEY CLUSTERED (ordid ASC, position ASC)
)
GO
----------------------------------------------------------------------------
-- orderdetails erfinden

WITH cte1 AS
(
	SELECT *
		FROM (VALUES (0, 1,5), (1, 4,12), (2, 6,19), (3, 4,7), (4, 7,7), (5, 8,16), (6, 15,16), (7, 2,3), (8, 5,8), (9, 11,13))
			  AS ranges(n, f, t)
), cte2 AS
(
	SELECT o.ordid, b.prodid, b.price, RAND(o.ordid*b.prodid) AS rnd,
			ROW_NUMBER() OVER (PARTITION BY o.ordid ORDER BY RAND(o.ordid*b.prodid) ) AS num
	FROM test1.orders AS o
	CROSS JOIN test1.books AS b
)
INSERT INTO test1.orderdetails (ordid, position, prodid, amount, price)
SELECT ordid, 
	ROW_NUMBER() OVER (PARTITION BY ordid ORDER	BY rnd) AS position,
	prodid, 
	CEILING(((rnd*10000)-FLOOR(rnd*10000))*10) AS amount,
	price
	-- ,rnd, num, f, t
FROM cte2 AS c2
JOIN cte1 AS c1
		ON c2.ordid%(SELECT COUNT(*) FROM cte1) = c1.n
WHERE c2.num BETWEEN c1.f AND c1.t
ORDER BY c2.ordid, c2.num;
GO
-- Total in orders berechnen
WITH cte1 AS 
(
	SELECT d.ordid, SUM(d.amount*d.price) as total
	FROM test1.orderdetails AS d
	GROUP BY d.ordid
)
UPDATE o
	SET	o.total = d.total*(1.0-c.discount/100.0)
--OUTPUT inserted.ordid, inserted.total
FROM	test1.orders AS o
JOIN	cte1 AS d
	ON	o.ordid = d.ordid
JOIN	test1.customers AS c
	ON  o.custid = c.custid
;
GO
CREATE VIEW test1.v_orderdetails 
AS
SELECT od.ordid, od.position, od.prodid, od.amount, od.price, o.uid
FROM test1.orderdetails AS od
JOIN test1.orders AS o
	ON od.ordid=o.ordid
WHERE o.uid=USER_ID();
GO
GRANT INSERT,UPDATE,DELETE,SELECT ON test1.v_orderdetails TO employees;
GO
IF OBJECT_ID('test1.v_customers2', 'V') IS NOT NULL
	DROP VIEW test1.v_customers2
GO
CREATE VIEW test1.v_customers2
AS
SELECT custid, 
       compname,
	   contact,
	   city,
	   country,
	   currid,
	   discount,
	   uid
FROM test1.customers
WHERE IS_MEMBER(USER_NAME(uid))=1;
GO
GRANT INSERT,UPDATE,DELETE,SELECT ON test1.v_customers2 TO employees;
GO

------------------------- 

CREATE TABLE test2.books 
(
	prodid		BIGINT		NOT NULL	IDENTITY(1,1),
	name		NVARCHAR(200)	COLLATE Latin1_General_CI_AS	NULL ,
	author		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	price		numeric(12,4)	NULL,
	CONSTRAINT [pk_product_prodid] PRIMARY KEY CLUSTERED (prodid ASC)
);
GO
-- Die Buchtitel stammen aus dem Gutenberg-Projekt. Dort findet man alle genannten bcher zum freuien Download
-- http://gutenberg.spiegel.de/
--
INSERT INTO test2.books (author, name)
VALUES
(N'Adolph, Karl', N'Haus Nummer 37'),
(N'Aho, Juhani', N'Schweres Blut'),
(N'Aho, Juhani', N'Gechtet'),
(N'Alarcn, Pedro Antonio de', N'Manuel Venegas'),
(N'Alberti, Karl', N'Japanische Mrchen'),
(N'Alexis, Willibald', N'Der Roland von Berlin  Erster Band'),
(N'Alexis, Willibald', N'Der Roland von Berlin  Zweiter Band'),
(N'Alexis, Willibald', N'Der Roland von Berlin  Dritter Band'),
(N'Andreas-Salom, Lou', N'Lebensrckblick'),
(N'Arnd, Friedrich', N'Das hohe Ziel der Erkenntnis'),
(N'Amicis, Edmondo De', N'Unsere Freunde'),
(N'Andrejew, Leonid Nikolajewitsch', N'Die Geschichte von den sieben Gehenkten'),
(N'Aram, Kurt', N'An den Ufern des Araxes'),
(N'Aretz, Gertrude', N'Berhmte Frauen der Weltgeschichte'),
(N'Arnim, Achim von', N'Erzhlungen'),
(N'Arnim, Achim von', N'Das Frhlingsfest'),
(N'Arnim, Achim von', N'Gedichte'),
(N'Arnim, Achim von', N'Die Gleichen'),
(N'Arnim, Achim von', N'Marino Caboga'),
(N'Arnim, Achim von', N'Miverstndnisse'),
(N'Arnim, Achim von', N'Die Vertreibung der Spanier aus Wesel im Jahre 1629'),
(N'Atterbom, Per Daniel Amadeus', N'Menschen und Stdte'),
(N'Auburtin, Victor', N'Das Ende des Odysseus'),
(N'Auburtin, Victor', N'Sndenflle. Feuilletons'),
(N'Auerbach, Berthold', N'Der Kindesmord'),
(N'Austen, Jane', N'Edgar und Emma'),
(N'Bahr, Hermann', N'Dostojewski'),
(N'Bahr, Hermann', N'Kritik der Gegenwart'),
(N'Balzac, Honor de', N'Adieu'),
(N'Balzac, Honor de', N'Die Geheimnisse der Frstin von Cadignan'),
(N'Balzac, Honor de', N'Kehrseite der Geschichte unserer Zeit'),
(N'Balzac, Honor de', N'Die Lilie im Tal'),
(N'Balzac, Honor de', N'Das Haus Nucingen'),
(N'Balzac, Honor de', N'Physiologie der Ehe'),
(N'Balzac, Honor de', N'Ein Drama am Ufer des Meeres'),
(N'Bang, Herman', N'Novellen und Skizzen. Gesamtwerk Band 9'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1880'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1881'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1882'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1883'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1884  Anhang'),
(N'Barbusse, Henri', N'Das Frhlicht'),
(N'Barlach, Ernst', N'Fragmente aus frherer Zeit'),
(N'Barlach, Ernst', N'Gstrower Fragmente'),
(N'Barlach, Ernst', N'Protokolle und Portrts'),
(N'Barlach, Ernst', N'Schriften in eigener Sache'),
(N'Barlach, Ernst', N'Seespeck'),
(N'Barlach, Ernst', N'Ein selbsterzhltes Leben'),
(N'Barthel, Max', N'Deutschland - Lichtbilder und Schattenrisse einer Reise'),
(N'Baudissin, Wolf Graf von', N'Die Kriegsurlauber'),
(N'Baumbach, Rudolf', N'Abenteuer und Schwnke'),
(N'Baumbach, Rudolf', N'Horand und Hilde'),
(N'Bebel, August', N'Aus meinem Leben  Erster Teil'),
(N'Bebel, August', N'Aus meinem Leben  Zweiter Teil'),
(N'Bebel, August', N'Die mohamedanisch-arabische Kulturperiode'),
(N'Bechstein, Ludwig', N'Der Dunkelgraf'),
(N'Bechstein, Ludwig', N'Rheinsagen'),
(N'Beeker, Kthe van', N'Hansis Europareise'),
(N'Beeker, Kthe van', N'Hansis Europareise'),
(N'Benjamin, Walter', N'Deutsche Menschen'),
(N'Benjamin, Walter', N'Stdtebilder'),
(N'Benjamin, Walter', N'Kritiken und Rezensionen 1912  1931'),
(N'Benjamin, Walter', N'Kritiken und Rezensionen 1932  1940'),
(N'Berend, Alice', N'Die gute alte Zeit'),
(N'Berend, Alice', N'Bruders Bekenntnis'),
(N'Berend, Alice', N'Frau Hempels Tochter'),
(N'Berend, Alice', N'Spreemann & Co'),
(N'Berend, Alice', N'Das verbrannte Bett'),
(N'Beringer, Josef August', N'Studien zur Deutschen Kunstgeschichte  Hermann Braun'),
(N'Bermann, Richard Arnold', N'Die Derwischtrommel'),
(N'Berthold, Theodor', N'Lustige Gymnasialgeschichten'),
(N'Bessels, Emil', N'196 Tage auf treibender Eisscholle'),
(N'Bierbaum, Otto Julius', N'Das hllische Automobil'),
(N'Bierbaum, Otto Julius', N'Das Madei'),
(N'Bierbaum, Otto Julius', N'Dostojewski'),
(N'Bierbaum, Otto Julius', N'Die Lavendel-Ehe'),
(N'Bierbaum, Otto Julius', N'Die rote Sphinx'),
(N'Bierbaum, Otto Julius', N'Die Weihnachts-Bowle'),
(N'Bierbaum, Otto Julius', N'Im Kahne'),
(N'Bierbaum, Otto Julius', N'Patsch und Tirili'),
(N'Bierbaum, Otto Julius', N'Schwarz-Rot-Gold und Grn-Wei-Rot'),
(N'Binding, Rudolf Georg', N'Legenden'),
(N'Binding, Rudolf Georg', N'Unsterblichkeit'),
(N'Binding, Rudolf Georg', N'Der Wingult'),
(N'Bischoff, Charitas', N'Bilder aus meinem Leben'),
(N'Bjrnson, Bjrnstjerne', N'Gedichte'),
(N'Bleibtreu, Karl', N'Bismarck  Band 4'),
(N'Bode, Wilhelm von', N'Fnfzig Jahre Museumsarbeit'),
(N'Bodenstedt, Friedrich von', N'Die Lieder des Mirza-Schaffy'),
(N'Bodenstedt, Friedrich von', N'Tausend und Ein Tag im Orient'),
(N'Bodkin, Mathias McDonnell', N'Giftmischer und andre Detektivgeschichten'),
(N'Bhlau, Helene', N'Altweimarische Liebes- und Ehegeschichten'),
(N'Bhlau, Helene', N'Die leichtsinnige Eheliebste'),
(N'Bhlau, Helene', N'Ein Sommerbuch'),
(N'Bhlau, Helene', N'Kristine'),
(N'Bhlau, Helene', N'Ratsmdelgeschichten'),
(N'Bhme, Margarete', N'Tagebuch einer Verlorenen'),
(N'Blsche, Wilhelm', N'Drachen'),
(N'Brne, Ludwig', N'Briefe aus Paris'),
(N'Bois-Reymond, Emil Heinrich du', N'ber die Grenzen des Naturerkennens  Die sieben Weltrthsel'),
(N'Bonaventura', N'Nachtwachen'),
(N'Brant, Sebastian', N'Das Narrenschiff'),
(N'Braun, Isabella', N'Gesammelte Erzhlungen'),
(N'Braun, Isabella', N'Geschichten aus der Jugendzeit'),
(N'Brentano, Clemens', N'Italienische Mrchen'),
(N'Blau, Friedrich von', N'Geheime Geschichten und rtselhafte Menschen  Zehntes Bndchen'),
(N'Bulwer-Lytton, Edward', N'Asmodeus aller Orten'),
(N'Bulwer-Lytton, Edward', N'Die Pilger des Rheins'),
(N'Burckhardt, Jacob', N'Reisebilder aus dem Sden'),
(N'Byr, Robert', N'Lydia'),
(N'Caldern de la Barca, Pedro', N'Das Versteckspiel'),
(N'Capek, Karel', N'Hordubal'),
(N'Carducci, Giosu', N'Gedichte'),
(N'Carducci, Giosu', N'Aus den Odi Barbare'),
(N'Carroll, Lewis', N'Alices Abenteuer im Wunderland'),
(N'Carus, Carl Gustav', N'Goethe zu dessen nherem Verstndnis'),
(N'Castelli, Ignaz', N'Wiener Lebensbilder'),
(N'Chamberlain, Houston Stewart', N'Kriegsaufstze'),
(N'Chamberlain, Houston Stewart', N'Mensch und Gott'),
(N'Christ, Lena', N'Lausdirndlgeschichten'),
(N'Cicero, Marcus Tullius', N'Reden gegen Verres'),
(N'Claudius, Matthias', N'Ein glden A B C'),
(N'Claudius, Matthias', N'Wiegenlied'),
(N'Clausewitz, Carl von', N'Kleine Schriften'),
(N'Colerus, Egmont', N'Zwei Welten - 1'),
(N'Colerus, Egmont', N'Zwei Welten - 2'),
(N'Colerus, Egmont', N'Leibniz'),
(N'Colerus, Egmont', N'Pythagoras'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band I'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band II'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band III'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band VI');
-- Titel und Autoren sind aus dem Gutenbergprojekt
GO
-- Preise vergeben 
WITH cte1 AS
(
	SELECT *
		FROM (VALUES (0, 3.99), (1, 8.99), (2, 7.99), (3, 6.99), (4, 5.50), (5, 12.90), (6, 24.90), (7, 10.50), (8, 9.50), (9, 9.99)
			 ) AS prices(n, price)
)
UPDATE b
	SET b.price = c.price
--OUTPUT inserted.prodid, inserted.price
FROM test2.books AS b
JOIN cte1 AS c
	ON b.prodid%10=c.n;
GO

/*--------------------------------------------------------------------------------------------------
2 View mit Verbindung zu SQL-User (1:n)
	 Userbezug nicht in Basistabelle, sondern in Zuordnungstabelle, ggf. mit R,W
*/

CREATE TABLE test2.customers
(
	custid		BIGINT			NOT NULL,
	compname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL ,
	contact		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	city		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	country		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	currid		CHAR(3)			COLLATE Latin1_General_CI_AS	NOT NULL	DEFAULT 'EUR',
	discount	smallint		NOT NULL DEFAULT 0,
	CONSTRAINT [pk_customers_custid] PRIMARY KEY CLUSTERED (custid ASC)
);
GO
INSERT INTO test2.customers 
		(custid, compname,				contact,				city,			country,		currid,		discount)
VALUES	
		(1,		N'Bcher Heinrich',		N'Thomas Heinrich',		N'Mnchen',		N'Deutschland',	N'EUR',		DEFAULT),
		(2,		N'London Books',		N'Steve Miller',		N'London',		N'Great Britain',	N'GBP',	5),
		(3,		N'modernes Antiquariat', N'Markus Buchbinder',	N'Kln',		N'Deutschland',	N'EUR',		2),
		(4,		N'Meiers Bcher',		N'Gustav Teuerkufer',	N'Nrnberg',	N'Deutschland',	N'EUR',		DEFAULT),
		(5,		N'Stberstube',			N'Hilda Hintersee',		N'Hamburg',		N'Deutschland',	N'EUR',		DEFAULT),
		(6,		N'Bcher Bucher',		N'Andreas Bucher',		N'Wien',		N'sterreich',	N'EUR',		DEFAULT),
		(7,		N'Bergers',				N'Carmen Berger',		N'Erlangen',	N'Deutschland',	N'EUR',		9),
		(8,		N'Schmker-Ecke',		N'Bernd Bauer',			N'Duisburg',	N'Deutschland',	N'EUR',		DEFAULT),
		(9,		N'Stberstube',			N'Elvira Sommer',		N'Bielefeld',	N'Deutschland',	N'EUR',		DEFAULT);
GO
CREATE TABLE test2.user2customers
(
	uid		BIGINT	NOT NULL,
	custid	BIGINT	NOT NULL,
		CONSTRAINT [pk_user2customers_custid_uid] PRIMARY KEY CLUSTERED (custid,uid),
		CONSTRAINT [fk_user2customers_custid] FOREIGN KEY (custid) REFERENCES test2.customers (custid)
);
GO
INSERT INTO test2.user2customers (uid, custid)
VALUES 
	(USER_ID('Tom'), 1),
	(USER_ID('Tom'), 2),
	(USER_ID('Tom'), 3),
	(USER_ID('Tom'), 4),
	(USER_ID('Bill'), 4),
	(USER_ID('Bill'), 5),
	(USER_ID('Bill'), 6),
	(USER_ID('Bill'), 7),
	(USER_ID('Mac'), 7),
	(USER_ID('Mac'), 8),
	(USER_ID('Mac'), 9),
	(USER_ID('Mac'), 1);
GO
CREATE VIEW test2.v_customers
AS
SELECT cust.custid, 
       cust.compname,
	   cust.contact,
	   cust.city,
	   cust.country,
	   cust.currid,
	   cust.discount,
	   uc.uid
FROM test2.customers AS cust
JOIN test2.user2customers AS uc
	ON cust.custid=uc.custid
WHERE IS_MEMBER(USER_NAME(uc.uid))=1;
;
GO
GRANT INSERT,UPDATE,DELETE,SELECT ON test2.v_customers TO employees;
GO
CREATE TABLE test2.orders
(
	ordid		BIGINT			NOT NULL	IDENTITY(1,1),
	custid		BIGINT			NOT NULL,
	uid			BIGINT			NULL		DEFAULT USER_ID(),
	orderdate	DATE			NOT NULL	DEFAULT CURRENT_TIMESTAMP,
	total		NUMERIC(20,4)	NULL,
	CONSTRAINT [pk_orders_ordid] PRIMARY KEY CLUSTERED (ordid ASC),
	CONSTRAINT [fk_orders_customers] FOREIGN KEY (custid) REFERENCES test2.customers (custid)
);
GO
CREATE VIEW test2.v_orders
AS
SELECT ordid, o.custid, o.uid, orderdate, total
FROM test2.orders AS o
JOIN test2.user2customers AS uc
	ON o.custid=uc.custid
WHERE IS_MEMBER(USER_NAME(uc.uid))=1;
GO
GRANT INSERT,UPDATE,DELETE,SELECT ON test2.v_orders TO employees;
GO
SET LANGUAGE german;
GO
WITH		-- Zahlen von 1 bis 1500 erzeugen
c1 AS	(	SELECT a.n FROM (VALUES (1),(1)) AS a(n)	),	-- 2
c2 AS	(	SELECT a.n FROM c1 AS a CROSS JOIN c1 AS b),	-- 4
c3 AS	(	SELECT a.n FROM c2 AS a CROSS JOIN c2 AS b),	-- 16
c4 AS	(	SELECT a.n FROM c3 AS a CROSS JOIN c3 AS b),	-- 256
c5 AS	(	SELECT a.n FROM c4 AS a CROSS JOIN c4 AS b),    -- 256*256
num AS  (	SELECT TOP(1500) ROW_NUMBER() OVER (ORDER BY (SELECT NULL)) AS n	FROM c5),
			-- Datum von 1.1.2009 bis 30.6.2012 erzeugen
d1 AS	(	SELECT n, DATEADD(day, n, CAST('20090101' AS DATE)) AS dt
			FROM num 
			WHERE DATENAME(weekday, DATEADD(day, n, CAST('20090101' AS DATE))) NOT IN ('Sonntag','Samstag')
			  AND DATEADD(day, n, CAST('20090101' AS DATE)) <= CAST('20120630' AS DATE)),
dat	AS	(	SELECT	dt, -- "zufllige" Reihenfolge erzeugen
					ROW_NUMBER() OVER (ORDER BY MONTH(dt)+YEAR(dt)+DAY(dt), n ASC) AS r
			FROM d1),
cu AS	(	SELECT	custid, LEN(city) AS v	FROM test2.customers	),
cu2 AS	(	SELECT ROW_NUMBER() OVER(ORDER BY d.dt) AS  orderid,
				c.custid, d.dt AS orderdate
			FROM dat AS d
			JOIN cu  AS c
				ON d.r%c.v = 0),
emp	AS  (	SELECT	id, 
					USER_ID(name) AS uid, 
					name 
			FROM (VALUES(2, 'Tom'),(3, 'Bill'),(1, 'Mac')) AS d(id, name))
INSERT INTO  test2.orders 
		(custid,	uid,	orderdate)
SELECT	custid,
		-- "Zufllig" den Angestellten ermitteln
		(SELECT MIN(emp.uid) FROM emp WHERE orderid%(emp.id)=0) AS uid,
		orderdate
FROM cu2
ORDER BY orderdate ASC, uid DESC, custid	ASC;
GO
CREATE INDEX i_order_date ON test2.orders (orderdate ASC);
GO
CREATE TABLE test2.orderdetails (
	ordid		BIGINT		NOT NULL	
		CONSTRAINT fk_orderdetails_ordid FOREIGN KEY REFERENCES test2.orders(ordid),
	position	INT			NOT NULL,
	prodid		BIGINT		NOT NULL
		CONSTRAINT fk_orderdetails_prodid FOREIGN KEY REFERENCES test2.books (prodid),
	amount		INT			NOT NULL,
	price		numeric(12,4)	NULL,
	CONSTRAINT [pk_orderdetails_orderid_position] PRIMARY KEY CLUSTERED (ordid ASC, position ASC)
)
GO
----------------------------------------------------------------------------
-- orderdetails erfinden

WITH cte1 AS
(
	SELECT *
		FROM (VALUES (0, 1,5), (1, 4,12), (2, 6,19), (3, 4,7), (4, 7,7), (5, 8,16), (6, 15,16), (7, 2,3), (8, 5,8), (9, 11,13))
			  AS ranges(n, f, t)
), cte2 AS
(
	SELECT o.ordid, b.prodid, b.price, RAND(o.ordid*b.prodid) AS rnd,
			ROW_NUMBER() OVER (PARTITION BY o.ordid ORDER BY RAND(o.ordid*b.prodid) ) AS num
	FROM test2.orders AS o
	CROSS JOIN test2.books AS b
)
INSERT INTO test2.orderdetails (ordid, position, prodid, amount, price)
SELECT ordid, 
	ROW_NUMBER() OVER (PARTITION BY ordid ORDER	BY rnd) AS position,
	prodid, 
	CEILING(((rnd*10000)-FLOOR(rnd*10000))*10) AS amount,
	price
	-- ,rnd, num, f, t
FROM cte2 AS c2
JOIN cte1 AS c1
		ON c2.ordid%(SELECT COUNT(*) FROM cte1) = c1.n
WHERE c2.num BETWEEN c1.f AND c1.t
ORDER BY c2.ordid, c2.num;
GO
-- Total in orders berechnen
WITH cte1 AS 
(
	SELECT d.ordid, SUM(d.amount*d.price) as total
	FROM test2.orderdetails AS d
	GROUP BY d.ordid
)
UPDATE o
	SET	o.total = d.total*(1.0-c.discount/100.0)
--OUTPUT inserted.ordid, inserted.total
FROM	test2.orders AS o
JOIN	cte1 AS d
	ON	o.ordid = d.ordid
JOIN	test2.customers AS c
	ON  o.custid = c.custid
;
GO
CREATE VIEW test2.v_orderdetails 
AS
SELECT od.ordid, od.position, od.prodid, od.amount, od.price, uc.uid
FROM test2.orderdetails AS od
JOIN test2.orders AS o
	ON o.ordid = od.ordid
JOIN test2.user2customers AS uc
	ON o.custid=uc.custid
WHERE IS_MEMBER(USER_NAME(uc.uid))=1;
GO
GRANT INSERT,UPDATE,DELETE,SELECT ON test2.v_orderdetails TO employees;
GO
----------------------

CREATE TABLE test3.users
(
	uid			BIGINT	NOT NULL,
	name		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL,
	CONSTRAINT [pk_users_uid] PRIMARY KEY CLUSTERED (uid ASC)
);
GO
INSERT INTO test3.users (uid, name)
VALUES
	(1, 'Tom'),
	(2, 'Bill'),
	(3, 'Mac');
GO
CREATE TABLE test3.books 
(
	prodid		BIGINT		NOT NULL	IDENTITY(1,1),
	name		NVARCHAR(200)	COLLATE Latin1_General_CI_AS	NULL ,
	author		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	price		numeric(12,4)	NULL,
	CONSTRAINT [pk_product_prodid] PRIMARY KEY CLUSTERED (prodid ASC)
);
GO
-- Die Buchtitel stammen aus dem Gutenberg-Projekt. Dort findet man alle genannten bcher zum freuien Download
-- http://gutenberg.spiegel.de/
--
INSERT INTO test3.books (author, name)
VALUES
(N'Adolph, Karl', N'Haus Nummer 37'),
(N'Aho, Juhani', N'Schweres Blut'),
(N'Aho, Juhani', N'Gechtet'),
(N'Alarcn, Pedro Antonio de', N'Manuel Venegas'),
(N'Alberti, Karl', N'Japanische Mrchen'),
(N'Alexis, Willibald', N'Der Roland von Berlin  Erster Band'),
(N'Alexis, Willibald', N'Der Roland von Berlin  Zweiter Band'),
(N'Alexis, Willibald', N'Der Roland von Berlin  Dritter Band'),
(N'Andreas-Salom, Lou', N'Lebensrckblick'),
(N'Arnd, Friedrich', N'Das hohe Ziel der Erkenntnis'),
(N'Amicis, Edmondo De', N'Unsere Freunde'),
(N'Andrejew, Leonid Nikolajewitsch', N'Die Geschichte von den sieben Gehenkten'),
(N'Aram, Kurt', N'An den Ufern des Araxes'),
(N'Aretz, Gertrude', N'Berhmte Frauen der Weltgeschichte'),
(N'Arnim, Achim von', N'Erzhlungen'),
(N'Arnim, Achim von', N'Das Frhlingsfest'),
(N'Arnim, Achim von', N'Gedichte'),
(N'Arnim, Achim von', N'Die Gleichen'),
(N'Arnim, Achim von', N'Marino Caboga'),
(N'Arnim, Achim von', N'Miverstndnisse'),
(N'Arnim, Achim von', N'Die Vertreibung der Spanier aus Wesel im Jahre 1629'),
(N'Atterbom, Per Daniel Amadeus', N'Menschen und Stdte'),
(N'Auburtin, Victor', N'Das Ende des Odysseus'),
(N'Auburtin, Victor', N'Sndenflle. Feuilletons'),
(N'Auerbach, Berthold', N'Der Kindesmord'),
(N'Austen, Jane', N'Edgar und Emma'),
(N'Bahr, Hermann', N'Dostojewski'),
(N'Bahr, Hermann', N'Kritik der Gegenwart'),
(N'Balzac, Honor de', N'Adieu'),
(N'Balzac, Honor de', N'Die Geheimnisse der Frstin von Cadignan'),
(N'Balzac, Honor de', N'Kehrseite der Geschichte unserer Zeit'),
(N'Balzac, Honor de', N'Die Lilie im Tal'),
(N'Balzac, Honor de', N'Das Haus Nucingen'),
(N'Balzac, Honor de', N'Physiologie der Ehe'),
(N'Balzac, Honor de', N'Ein Drama am Ufer des Meeres'),
(N'Bang, Herman', N'Novellen und Skizzen. Gesamtwerk Band 9'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1880'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1881'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1882'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1883'),
(N'Bang, Herman', N'Reportagen zu wechselnden Themen  1884  Anhang'),
(N'Barbusse, Henri', N'Das Frhlicht'),
(N'Barlach, Ernst', N'Fragmente aus frherer Zeit'),
(N'Barlach, Ernst', N'Gstrower Fragmente'),
(N'Barlach, Ernst', N'Protokolle und Portrts'),
(N'Barlach, Ernst', N'Schriften in eigener Sache'),
(N'Barlach, Ernst', N'Seespeck'),
(N'Barlach, Ernst', N'Ein selbsterzhltes Leben'),
(N'Barthel, Max', N'Deutschland - Lichtbilder und Schattenrisse einer Reise'),
(N'Baudissin, Wolf Graf von', N'Die Kriegsurlauber'),
(N'Baumbach, Rudolf', N'Abenteuer und Schwnke'),
(N'Baumbach, Rudolf', N'Horand und Hilde'),
(N'Bebel, August', N'Aus meinem Leben  Erster Teil'),
(N'Bebel, August', N'Aus meinem Leben  Zweiter Teil'),
(N'Bebel, August', N'Die mohamedanisch-arabische Kulturperiode'),
(N'Bechstein, Ludwig', N'Der Dunkelgraf'),
(N'Bechstein, Ludwig', N'Rheinsagen'),
(N'Beeker, Kthe van', N'Hansis Europareise'),
(N'Beeker, Kthe van', N'Hansis Europareise'),
(N'Benjamin, Walter', N'Deutsche Menschen'),
(N'Benjamin, Walter', N'Stdtebilder'),
(N'Benjamin, Walter', N'Kritiken und Rezensionen 1912  1931'),
(N'Benjamin, Walter', N'Kritiken und Rezensionen 1932  1940'),
(N'Berend, Alice', N'Die gute alte Zeit'),
(N'Berend, Alice', N'Bruders Bekenntnis'),
(N'Berend, Alice', N'Frau Hempels Tochter'),
(N'Berend, Alice', N'Spreemann & Co'),
(N'Berend, Alice', N'Das verbrannte Bett'),
(N'Beringer, Josef August', N'Studien zur Deutschen Kunstgeschichte  Hermann Braun'),
(N'Bermann, Richard Arnold', N'Die Derwischtrommel'),
(N'Berthold, Theodor', N'Lustige Gymnasialgeschichten'),
(N'Bessels, Emil', N'196 Tage auf treibender Eisscholle'),
(N'Bierbaum, Otto Julius', N'Das hllische Automobil'),
(N'Bierbaum, Otto Julius', N'Das Madei'),
(N'Bierbaum, Otto Julius', N'Dostojewski'),
(N'Bierbaum, Otto Julius', N'Die Lavendel-Ehe'),
(N'Bierbaum, Otto Julius', N'Die rote Sphinx'),
(N'Bierbaum, Otto Julius', N'Die Weihnachts-Bowle'),
(N'Bierbaum, Otto Julius', N'Im Kahne'),
(N'Bierbaum, Otto Julius', N'Patsch und Tirili'),
(N'Bierbaum, Otto Julius', N'Schwarz-Rot-Gold und Grn-Wei-Rot'),
(N'Binding, Rudolf Georg', N'Legenden'),
(N'Binding, Rudolf Georg', N'Unsterblichkeit'),
(N'Binding, Rudolf Georg', N'Der Wingult'),
(N'Bischoff, Charitas', N'Bilder aus meinem Leben'),
(N'Bjrnson, Bjrnstjerne', N'Gedichte'),
(N'Bleibtreu, Karl', N'Bismarck  Band 4'),
(N'Bode, Wilhelm von', N'Fnfzig Jahre Museumsarbeit'),
(N'Bodenstedt, Friedrich von', N'Die Lieder des Mirza-Schaffy'),
(N'Bodenstedt, Friedrich von', N'Tausend und Ein Tag im Orient'),
(N'Bodkin, Mathias McDonnell', N'Giftmischer und andre Detektivgeschichten'),
(N'Bhlau, Helene', N'Altweimarische Liebes- und Ehegeschichten'),
(N'Bhlau, Helene', N'Die leichtsinnige Eheliebste'),
(N'Bhlau, Helene', N'Ein Sommerbuch'),
(N'Bhlau, Helene', N'Kristine'),
(N'Bhlau, Helene', N'Ratsmdelgeschichten'),
(N'Bhme, Margarete', N'Tagebuch einer Verlorenen'),
(N'Blsche, Wilhelm', N'Drachen'),
(N'Brne, Ludwig', N'Briefe aus Paris'),
(N'Bois-Reymond, Emil Heinrich du', N'ber die Grenzen des Naturerkennens  Die sieben Weltrthsel'),
(N'Bonaventura', N'Nachtwachen'),
(N'Brant, Sebastian', N'Das Narrenschiff'),
(N'Braun, Isabella', N'Gesammelte Erzhlungen'),
(N'Braun, Isabella', N'Geschichten aus der Jugendzeit'),
(N'Brentano, Clemens', N'Italienische Mrchen'),
(N'Blau, Friedrich von', N'Geheime Geschichten und rtselhafte Menschen  Zehntes Bndchen'),
(N'Bulwer-Lytton, Edward', N'Asmodeus aller Orten'),
(N'Bulwer-Lytton, Edward', N'Die Pilger des Rheins'),
(N'Burckhardt, Jacob', N'Reisebilder aus dem Sden'),
(N'Byr, Robert', N'Lydia'),
(N'Caldern de la Barca, Pedro', N'Das Versteckspiel'),
(N'Capek, Karel', N'Hordubal'),
(N'Carducci, Giosu', N'Gedichte'),
(N'Carducci, Giosu', N'Aus den Odi Barbare'),
(N'Carroll, Lewis', N'Alices Abenteuer im Wunderland'),
(N'Carus, Carl Gustav', N'Goethe zu dessen nherem Verstndnis'),
(N'Castelli, Ignaz', N'Wiener Lebensbilder'),
(N'Chamberlain, Houston Stewart', N'Kriegsaufstze'),
(N'Chamberlain, Houston Stewart', N'Mensch und Gott'),
(N'Christ, Lena', N'Lausdirndlgeschichten'),
(N'Cicero, Marcus Tullius', N'Reden gegen Verres'),
(N'Claudius, Matthias', N'Ein glden A B C'),
(N'Claudius, Matthias', N'Wiegenlied'),
(N'Clausewitz, Carl von', N'Kleine Schriften'),
(N'Colerus, Egmont', N'Zwei Welten - 1'),
(N'Colerus, Egmont', N'Zwei Welten - 2'),
(N'Colerus, Egmont', N'Leibniz'),
(N'Colerus, Egmont', N'Pythagoras'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band I'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band II'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band III'),
(N'Collins, William Wilkie', N'Die Frau in Wei  Band VI');
-- Titel und Autoren sind aus dem Gutenbergprojekt
GO
-- Preise vergeben 
WITH cte1 AS
(
	SELECT *
		FROM (VALUES (0, 3.99), (1, 8.99), (2, 7.99), (3, 6.99), (4, 5.50), (5, 12.90), (6, 24.90), (7, 10.50), (8, 9.50), (9, 9.99)
			 ) AS prices(n, price)
)
UPDATE b
	SET b.price = c.price
--OUTPUT inserted.prodid, inserted.price
FROM test3.books AS b
JOIN cte1 AS c
	ON b.prodid%10=c.n;
GO

CREATE TABLE test3.customers
(
	custid		BIGINT			NOT NULL,
	compname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL ,
	contact		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	city		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	country		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	currid		CHAR(3)			COLLATE Latin1_General_CI_AS	NOT NULL	DEFAULT 'EUR',
	discount	smallint		NOT NULL DEFAULT 0,
	CONSTRAINT [pk_customers_custid] PRIMARY KEY CLUSTERED (custid ASC)
);
GO
INSERT INTO test3.customers 
		(custid, compname,				contact,				city,			country,		currid,		discount)
VALUES	
		(1,		N'Bcher Heinrich',		N'Thomas Heinrich',		N'Mnchen',		N'Deutschland',	N'EUR',		DEFAULT),
		(2,		N'London Books',		N'Steve Miller',		N'London',		N'Great Britain',	N'GBP',	5),
		(3,		N'modernes Antiquariat', N'Markus Buchbinder',	N'Kln',		N'Deutschland',	N'EUR',		2),
		(4,		N'Meiers Bcher',		N'Gustav Teuerkufer',	N'Nrnberg',	N'Deutschland',	N'EUR',		DEFAULT),
		(5,		N'Stberstube',			N'Hilda Hintersee',		N'Hamburg',		N'Deutschland',	N'EUR',		DEFAULT),
		(6,		N'Bcher Bucher',		N'Andreas Bucher',		N'Wien',		N'sterreich',	N'EUR',		DEFAULT),
		(7,		N'Bergers',				N'Carmen Berger',		N'Erlangen',	N'Deutschland',	N'EUR',		9),
		(8,		N'Schmker-Ecke',		N'Bernd Bauer',			N'Duisburg',	N'Deutschland',	N'EUR',		DEFAULT),
		(9,		N'Stberstube',			N'Elvira Sommer',		N'Bielefeld',	N'Deutschland',	N'EUR',		DEFAULT);
GO
CREATE TABLE test3.user2customers
(
	uid		BIGINT	NOT NULL,
	custid	BIGINT	NOT NULL,
		CONSTRAINT [pk_user2customers_custid_uid] PRIMARY KEY CLUSTERED (custid,uid),
		CONSTRAINT [fk_user2customers_custid]     FOREIGN KEY (custid) REFERENCES test3.customers (custid),
		CONSTRAINT [fk_user2customers_uid]        FOREIGN KEY (uid) REFERENCES test3.users (uid)
);
GO
INSERT INTO test3.user2customers (uid, custid)
VALUES 
	(1, 1),
	(1, 2),
	(1, 3),
	(1, 4),
	(2, 4),
	(2, 5),
	(2, 6),
	(2, 7),
	(3, 7),
	(3, 8),
	(3, 9),
	(3, 1);
GO
GO
CREATE TABLE test3.orders
(
	ordid		BIGINT			NOT NULL	IDENTITY(1,1),
	custid		BIGINT			NOT NULL,
	orderdate	DATE			NOT NULL	DEFAULT CURRENT_TIMESTAMP,
	total		NUMERIC(20,4)	NULL,
	CONSTRAINT [pk_orders_ordid] PRIMARY KEY CLUSTERED (ordid ASC),
	CONSTRAINT [fk_orders_customers] FOREIGN KEY (custid) REFERENCES test3.customers (custid)
);
GO
GO
SET LANGUAGE german;
GO
WITH		-- Zahlen von 1 bis 1500 erzeugen
c1 AS	(	SELECT a.n FROM (VALUES (1),(1)) AS a(n)	),	-- 2
c2 AS	(	SELECT a.n FROM c1 AS a CROSS JOIN c1 AS b),	-- 4
c3 AS	(	SELECT a.n FROM c2 AS a CROSS JOIN c2 AS b),	-- 16
c4 AS	(	SELECT a.n FROM c3 AS a CROSS JOIN c3 AS b),	-- 256
c5 AS	(	SELECT a.n FROM c4 AS a CROSS JOIN c4 AS b),    -- 256*256
num AS  (	SELECT TOP(1500) ROW_NUMBER() OVER (ORDER BY (SELECT NULL)) AS n	FROM c5),
			-- Datum von 1.1.2009 bis 30.6.2012 erzeugen
d1 AS	(	SELECT n, DATEADD(day, n, CAST('20090101' AS DATE)) AS dt
			FROM num 
			WHERE DATENAME(weekday, DATEADD(day, n, CAST('20090101' AS DATE))) NOT IN ('Sonntag','Samstag')
			  AND DATEADD(day, n, CAST('20090101' AS DATE)) <= CAST('20120630' AS DATE)),
dat	AS	(	SELECT	dt, -- "zufllige" Reihenfolge erzeugen
					ROW_NUMBER() OVER (ORDER BY MONTH(dt)+YEAR(dt)+DAY(dt), n ASC) AS r
			FROM d1),
cu AS	(	SELECT	custid, LEN(city) AS v	FROM test3.customers	),
cu2 AS	(	SELECT ROW_NUMBER() OVER(ORDER BY d.dt) AS  orderid,
				c.custid, d.dt AS orderdate
			FROM dat AS d
			JOIN cu  AS c
				ON d.r%c.v = 0)
INSERT INTO  test3.orders 
		(custid,	orderdate)
SELECT	custid,
		orderdate
FROM cu2
ORDER BY orderdate ASC, custid	ASC;
GO
CREATE INDEX i_order_date ON test3.orders (orderdate ASC);
GO
CREATE TABLE test3.orderdetails (
	ordid		BIGINT		NOT NULL	
		CONSTRAINT fk_orderdetails_ordid FOREIGN KEY REFERENCES test3.orders(ordid),
	position	INT			NOT NULL,
	prodid		BIGINT		NOT NULL
		CONSTRAINT fk_orderdetails_prodid FOREIGN KEY REFERENCES test3.books (prodid),
	amount		INT			NOT NULL,
	price		numeric(12,4)	NULL,
	CONSTRAINT [pk_orderdetails_orderid_position] PRIMARY KEY CLUSTERED (ordid ASC, position ASC)
)
GO
----------------------------------------------------------------------------
-- orderdetails erfinden

WITH cte1 AS
(
	SELECT *
		FROM (VALUES (0, 1,5), (1, 4,12), (2, 6,19), (3, 4,7), (4, 7,7), (5, 8,16), (6, 15,16), (7, 2,3), (8, 5,8), (9, 11,13))
			  AS ranges(n, f, t)
), cte2 AS
(
	SELECT o.ordid, b.prodid, b.price, RAND(o.ordid*b.prodid) AS rnd,
			ROW_NUMBER() OVER (PARTITION BY o.ordid ORDER BY RAND(o.ordid*b.prodid) ) AS num
	FROM test3.orders AS o
	CROSS JOIN test3.books AS b
)
INSERT INTO test3.orderdetails (ordid, position, prodid, amount, price)
SELECT ordid, 
	ROW_NUMBER() OVER (PARTITION BY ordid ORDER	BY rnd) AS position,
	prodid, 
	CEILING(((rnd*10000)-FLOOR(rnd*10000))*10) AS amount,
	price
	-- ,rnd, num, f, t
FROM cte2 AS c2
JOIN cte1 AS c1
		ON c2.ordid%(SELECT COUNT(*) FROM cte1) = c1.n
WHERE c2.num BETWEEN c1.f AND c1.t
ORDER BY c2.ordid, c2.num;
GO
-- Total in orders berechnen
WITH cte1 AS 
(
	SELECT d.ordid, SUM(d.amount*d.price) as total
	FROM test3.orderdetails AS d
	GROUP BY d.ordid
)
UPDATE o
	SET	o.total = d.total*(1.0-c.discount/100.0)
--OUTPUT inserted.ordid, inserted.total
FROM	test3.orders AS o
JOIN	cte1 AS d
	ON	o.ordid = d.ordid
JOIN	test3.customers AS c
	ON  o.custid = c.custid
;
GO

GO
--SELECT * FROM test3.orderdetails 

--------------------------------------------------------------------------------------------
CREATE FUNCTION test3.f_customers
(@name	NVARCHAR(100))
RETURNS TABLE
RETURN (
		SELECT c.custid, compname, contact,	city, country, currid, discount, uc.uid
		FROM test3.customers AS c
		JOIN test3.user2customers AS uc
			ON c.custid=uc.custid
		JOIN test3.users AS u
			ON uc.uid=u.uid
		WHERE u.name = @name);
GO
GRANT INSERT,UPDATE,DELETE,SELECT ON test3.f_customers TO employee;
GO

CREATE FUNCTION test3.f_orders
(@name	NVARCHAR(100))
RETURNS TABLE
RETURN (SELECT ordid, o.custid, orderdate, total
		FROM test3.orders AS o
		JOIN test3.user2customers AS uc
			ON o.custid=uc.custid
		JOIN test3.users AS u
			ON uc.uid=u.uid
		WHERE u.name IN( @name, 'Any'));
GO
GRANT INSERT,UPDATE,DELETE,SELECT ON test3.f_orders TO employee;
GO

CREATE FUNCTION test3.f_orderdetails 
(@name	NVARCHAR(100))
RETURNS TABLE
RETURN (SELECT od.ordid, od.position, od.prodid, od.amount, od.price, uc.uid
		FROM test3.orderdetails AS od
		JOIN test3.orders AS o
			ON	o.ordid = od.ordid
		JOIN test3.user2customers AS uc
			ON o.custid=uc.custid
		JOIN test3.users AS u
			ON uc.uid=u.uid
		WHERE u.name IN( @name, 'Any'));
GO
GRANT INSERT,UPDATE,DELETE,SELECT ON test3.f_orderdetails TO employee;
GO

-------------------------------------------------------------------------------
-- Kap 7
----------------- 

GO
CREATE TABLE [dbo].[customers](
	[custno] [bigint] NOT NULL,
	[compname] [nvarchar](100) NOT NULL,
	[firstname] [nvarchar](100) NULL,
	[lastname] [nvarchar](100) NULL,
	[city] [nvarchar](100) NULL,
	[country] [nvarchar](100) NULL,
	[currid] [char](3) NOT NULL DEFAULT ('EUR'),
	[discount] [smallint] NOT NULL DEFAULT (0),
 CONSTRAINT [pk_customers_custno] PRIMARY KEY CLUSTERED ([custno] ASC) 
)
GO
CREATE TABLE [dbo].[orders](
	[id] [int] NOT NULL,
	[descr] [nvarchar](50) NULL,
	[num] [int] NULL,
	[price] [numeric](12, 2) NULL,
	[custno] [int] NULL,
	[custname] [sysname] NULL
)
GO
CREATE TABLE dbo.trans 
(
	id INTEGER PRIMARY KEY, 
	name NVARCHAR(100), 
	descr NVARCHAR(2000)
);
GO
CREATE TABLE dbo.[users]
(
	id INTEGER PRIMARY KEY, 
	name NVARCHAR(100), 
	password NVARCHAR(100), 
	type nvarchar(20)
);



GO
---------------------------------------------------------------------
-- Hashing###

CREATE TABLE hashdemo.users
(
	uid			BIGINT	NOT NULL,
	name		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL,
	pwd			VARBINARY(64) NULL,
	pwddate		DATETIME	NULL,
	locked		BIT	NOT NULL	DEFAULT 1,
	CONSTRAINT [pk_users_uid] PRIMARY KEY CLUSTERED (uid ASC),
	CONSTRAINT [u_users_name] UNIQUE (uid)
);
GO
INSERT INTO hashdemo.users (uid, name)
VALUES
	(1, 'Tom'),
	(2, 'Bill'),
	(3, 'Mac'),
	(4, 'Dan');
GO

---------------------------------------------------------------------
-- Hashing 2

CREATE TABLE changecheck1.customers
(
	custid		BIGINT			NOT NULL,
	compname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL ,
	contact		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	city		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	country		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	currid		CHAR(3)			COLLATE Latin1_General_CI_AS	NOT NULL	DEFAULT 'EUR',
	discount	smallint		NOT NULL DEFAULT 0,
	chcksum		VARBINARY(32)	NULL,
	CONSTRAINT [pk_customers_custid] PRIMARY KEY CLUSTERED (custid ASC)
)
GO
CREATE INDEX i_customer_checksum_custid ON changecheck1.customers (chcksum, custid);
GO
CREATE TABLE changecheck1.customers_copy
(
	custid		BIGINT			NOT NULL,
	compname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL ,
	contact		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	city		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	country		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	currid		CHAR(3)			COLLATE Latin1_General_CI_AS	NOT NULL	DEFAULT 'EUR',
	discount	smallint		NOT NULL DEFAULT 0,
	chcksum		VARBINARY(32)	NULL,
	CONSTRAINT [pk_customers_copy_custid] PRIMARY KEY CLUSTERED (custid ASC)
)
GO
CREATE INDEX i_customer_copy_checksum_custid ON changecheck1.customers_copy (chcksum, custid);
GO

---------------------------------------------------------------------
-- Signatur mit Zertifikat

CREATE TABLE changecheck2.customers
(
	custid		BIGINT			NOT NULL,
	compname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL ,
	contact		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	city		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	country		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	currid		CHAR(3)			COLLATE Latin1_General_CI_AS	NOT NULL	DEFAULT 'EUR',
	discount	smallint		NOT NULL DEFAULT 0,
	signatur	VARBINARY(128)	NULL,
	CONSTRAINT [pk_customers_custid] PRIMARY KEY CLUSTERED (custid ASC)
)
GO

---------------------------------------------------------------------
-- Signatur mit AsmKey

CREATE TABLE changecheck3.customers
(
	custid		BIGINT			NOT NULL,
	compname	NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NOT NULL ,
	contact		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	city		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	country		NVARCHAR(100)	COLLATE Latin1_General_CI_AS	NULL ,
	currid		CHAR(3)			COLLATE Latin1_General_CI_AS	NOT NULL	DEFAULT 'EUR',
	discount	smallint		NOT NULL DEFAULT 0,
	signatur	VARBINARY(256)	NULL,
	CONSTRAINT [pk_customers_custid] PRIMARY KEY CLUSTERED (custid ASC)
)
GO





